=== debian/rules ===
#!/usr/bin/make -f

#ifeq ($(DEB_HOST_ARCH_CPU),amd64)
#	confflags=-DVVENC_ENABLE_X86_SIMD=TRUE
#else
#	confflags=-DVVENC_ENABLE_X86_SIMD=FALSE
#endif

%:
	dh $@ -Scmake+ninja --with quilt

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_SHARED_LIBS=ON \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DCMAKE_SKIP_INSTALL_RPATH=ON \
	-DVVENC_ENABLE_INSTALL=ON \
	-DVVENC_ENABLE_LINK_TIME_OPT=OFF \
	$(confflags)

#	exit 1

override_dh_clean:
	dh_clean

	rm -rf bin
	rm -rf lib

override_dh_auto_test:
