## vvenc-dmo 1.13.1

=== debian/changelog ===
vvenc-dmo (1.13.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 21 Mar 2025 23:38:05 +0100

vvenc-dmo (1.13.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Sat, 14 Dec 2024 11:55:03 +0100

vvenc-dmo (1.12.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 28 Oct 2024 16:24:49 +0100

vvenc-dmo (1.12.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Thu, 27 Jun 2024 14:56:19 +0200

vvenc-dmo (1.11.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 05 Mar 2024 00:43:14 +0100

vvenc-dmo (1.11.0-dmo2) unstable; urgency=medium

  * Fix build for arm64 but this version doesn't build for armel and armhf.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 21 Feb 2024 08:52:19 +0100

vvenc-dmo (1.11.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Wed, 21 Feb 2024 07:50:08 +0100

vvenc-dmo (1.10.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 15 Dec 2023 07:50:01 +0100

vvenc-dmo (1.9.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 19 Sep 2023 11:45:47 +0200

vvenc-dmo (1.9.0-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Fri, 28 Jul 2023 16:09:44 +0200
