=== debian/control ===
--- 
+++ 
@@ -4,8 +4,7 @@
 Maintainer: Christian Marillat <marillat@deb-multimedia.org>
 Bugs: mailto:marillat@deb-multimedia.org
 Homepage: https://github.com/fraunhoferhhi/vvenc/releases
-Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Build-Depends: debhelper-compat (= 13), cmake (>= 3.13.0~), ninja-build, quilt
 
 Package: vvenc
@@ -36,7 +35,7 @@
   * Expert mode encoder interface available, allowing fine-grained control
     of the encoding proces.
 
-Package: libvvenc0
+Package: libvvenc1.13
 Architecture: any
 Section: libs
 Multi-Arch: same
@@ -72,7 +71,7 @@
 Architecture: any
 Section: libdevel
 Multi-Arch: same
-Depends: libvvenc0 (= ${binary:Version}), ${misc:Depends}
+Depends: libvvenc1.13 (= ${binary:Version}), ${misc:Depends}
 Description: Fraunhofer Versatile Video Encoder - devel files.
  Versatile Video Coding (VVC) is the most recent international video coding
  standard, developed by the Joint Video Experts Team (JVET) of the ITU-T
