=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,8 @@
 #!/usr/bin/make -f
 
-#ifeq ($(DEB_HOST_ARCH_CPU),amd64)
-#	confflags=-DVVENC_ENABLE_X86_SIMD=TRUE
-#else
-#	confflags=-DVVENC_ENABLE_X86_SIMD=FALSE
-#endif
+ifeq "$(DEB_BUILD_ARCH)" "armel"
+	confflags = -DVVENC_ENABLE_ARM_SIMD=OFF
+endif
 
 %:
 	dh $@ -Scmake+ninja --with quilt
